diff -BbruN freeswan-1.91.orig/pluto/spdb.c freeswan-1.91/pluto/spdb.c
--- freeswan-1.91.orig/pluto/spdb.c	Mon Apr  9 15:48:43 2001
+++ freeswan-1.91/pluto/spdb.c	Tue Jul  3 02:56:34 2001
@@ -645,6 +1208,180 @@
     return val;
 }
 
+#ifdef OPENSSL
+struct _trans_node {
+  struct oakley_trans_attrs ta;
+  struct isakmp_transform trans;
+  u_char *attr_start;
+  size_t attr_len;
+  bool elim; /* has this node been eliminated from the selection process */
+  struct _trans_node *next;
+};
+
+typedef struct _trans_node *trans_list;
+
+/* Free a list of Oakley transforms */
+static void
+trans_list_free( trans_list *l )
+{
+  trans_list p;
+
+  if (!l) return;
+  while (*l) {
+    p = *l;
+    *l = p->next;
+    pfree(p->attr_start);
+    pfree(p);
+  }
+}
+
+static void
+trans_list_append(trans_list *l,
+		  struct oakley_trans_attrs *ta,
+		  struct isakmp_transform *trans,
+		  u_char *attr_start,
+		  size_t attr_len) {
+  trans_list p, pp;
+
+  if (!l) return;
+  if ((p = alloc_bytes(sizeof(struct _trans_node),
+		       "transformation node")) == NULL) return;
+  p->ta = *ta;
+  p->trans = *trans;
+  p->attr_len = attr_len;
+  if ((p->attr_start = alloc_bytes(attr_len, "attribute")) == NULL) {
+    pfree(p);
+    return;
+  }
+  memcpy(p->attr_start, attr_start, attr_len);
+  p->elim = FALSE;
+  p->next = NULL;
+  if (*l == NULL) {
+    *l = p;
+  } else {
+    for(pp = *l; pp->next ; pp = pp->next);
+    pp->next = p;
+  }
+}
+
+static bool
+select_trans_candidate(trans_list l,
+		       struct oakley_trans_attrs *ta,
+		       struct isakmp_transform *trans,
+		       u_char **attr_start,
+		       size_t *attr_len,
+		       u_int32_t opts)
+{
+  bool ret = FALSE;
+  trans_list auth[OAKLEY_ELGAMAL_ENC_REV+1], p;
+  uint i, numprefs, pref[10];
+
+  if (!l) {
+    DBG(DBG_PARSING,
+    DBG_log("No candidate transforms to choose from");
+    );
+    return FALSE;
+  }
+
+  if ((!ta) || (!attr_len) || (!trans) || (!attr_start)) {
+    DBG(DBG_PARSING,
+    DBG_log("No space to store selected transform");
+    );
+    return FALSE;
+  }
+
+  /* Separate all elements of the list by authentication method */
+
+  for(i=OAKLEY_PRESHARED_KEY; i<=OAKLEY_ELGAMAL_ENC_REV; i++)
+    auth[i] = NULL;
+  for(p=l; p; p=p->next)
+    if ((p->ta.auth >= OAKLEY_PRESHARED_KEY) &&
+	(p->ta.auth <= OAKLEY_ELGAMAL_ENC_REV )) {
+      trans_list_append(&(auth[p->ta.auth]),
+			&(p->ta),
+			&(p->trans),
+			p->attr_start,
+			p->attr_len);
+    }
+
+  numprefs = 7;
+  pref[numprefs-1] = OAKLEY_PRESHARED_KEY;
+  DBG(DBG_PARSING | DBG_CRYPT,
+  DBG_log("select_trans_candidate: %08x", opts);
+  );
+  if (opts & CERT_OPTION_PK) {
+    if (opts & CERT_OPTION_REV) {
+      DBG(DBG_PARSING | DBG_CRYPT,
+      DBG_log("Preferring revised PK encryption schemes");
+      );
+      pref[0] = OAKLEY_ELGAMAL_ENC_REV;
+      pref[1] = OAKLEY_RSA_ENC_REV;
+      pref[2] = OAKLEY_ELGAMAL_ENC;
+      pref[3] = OAKLEY_RSA_ENC;
+      pref[4] = OAKLEY_RSA_SIG;
+      pref[5] = OAKLEY_DSS_SIG;
+    } else {
+      DBG(DBG_PARSING | DBG_CRYPT,
+      DBG_log("Preferring standard PK encryption schemes");
+      );
+      pref[0] = OAKLEY_ELGAMAL_ENC;
+      pref[1] = OAKLEY_RSA_ENC;
+      pref[2] = OAKLEY_ELGAMAL_ENC_REV;
+      pref[3] = OAKLEY_RSA_ENC_REV;
+      pref[4] = OAKLEY_RSA_SIG;
+      pref[5] = OAKLEY_DSS_SIG;
+    }
+  } else {
+    if (opts & CERT_OPTION_REV) {
+      DBG(DBG_PARSING | DBG_CRYPT,
+      DBG_log("Preferring digisig schemes, then revised pk");
+      );
+      pref[0] = OAKLEY_RSA_SIG;
+      pref[1] = OAKLEY_DSS_SIG;
+      pref[2] = OAKLEY_ELGAMAL_ENC_REV;
+      pref[3] = OAKLEY_RSA_ENC_REV;
+      pref[4] = OAKLEY_ELGAMAL_ENC;
+      pref[5] = OAKLEY_RSA_ENC;
+    } else {
+      DBG(DBG_PARSING | DBG_CRYPT,
+      DBG_log("Preferring digisig schemes, then standard pk");
+      );
+      pref[0] = OAKLEY_RSA_SIG;
+      pref[1] = OAKLEY_DSS_SIG;
+      pref[2] = OAKLEY_ELGAMAL_ENC;
+      pref[3] = OAKLEY_RSA_ENC;
+      pref[4] = OAKLEY_ELGAMAL_ENC_REV;
+      pref[5] = OAKLEY_RSA_ENC_REV;
+    }
+  }
+
+  for(i=0; ((i<numprefs) && (!ret)); i++) {
+    DBG(DBG_PARSING,
+    DBG_log("Trying out: %s", enum_show(&oakley_auth_names, pref[i]));
+    );
+    if ((pref[i]) && (auth[pref[i]])) {
+      ret = TRUE;
+      *ta = auth[pref[i]]->ta;
+      *trans = auth[pref[i]]->trans;
+      *attr_start = alloc_bytes(auth[pref[i]]->attr_len, "attribute");
+      if (*attr_start) {
+	*attr_len = auth[pref[i]]->attr_len;
+	memcpy(*attr_start, auth[pref[i]]->attr_start, *attr_len);
+      }
+      DBG(DBG_PARSING,
+      DBG_log("Candidate selected: %s", 
+        enum_show(&oakley_auth_names, pref[i]));
+      );
+    }
+}
+  
+  for(i=OAKLEY_PRESHARED_KEY; i<=OAKLEY_RSA_ENC_REV; i++) {
+    trans_list_free(&auth[i]);
+  }
+  return ret;
+}
+#endif
+
 /* Parse the body of an ISAKMP SA Payload (i.e. Phase 1 / Main Mode).
  * Various shortcuts are taken.  In particular, the policy, such as
  * it is, is hardwired.
@@ -674,6 +1411,12 @@
     struct isakmp_proposal proposal;
     unsigned no_trans_left;
     int last_transnum;
+    const struct connection *c = st->st_connection;
+    
+#ifdef OPENSSL
+    bool selected;
+    trans_list tl = NULL;
+#endif
 
     /* DOI */
     if (sa->isasa_doi != ISAKMP_DOI_IPSEC)
@@ -859,12 +1602,25 @@
 		case OAKLEY_ENCRYPTION_ALGORITHM | ISAKMP_ATTR_AF_TV:
 		    switch (val)
 		    {
-#if 0	/* we don't feel DES is safe */
 		    case OAKLEY_DES_CBC:
-#endif
+			if ((c->block_cypher == ALL_BLOCK_CYPHER) ||
+			  (c->block_cypher == DES_BLOCK_CYPHER)) {
+			  ta.encrypt = val;
+			  ta.encrypter = &oakley_encrypter[val];
+			} else {
+                       ugh = builddiag("%s is not supported",
+			    enum_show(&oakley_enc_names, val));
+			}
+			break;
 		    case OAKLEY_3DES_CBC:
+			if ((c->block_cypher == ALL_BLOCK_CYPHER) ||
+			  (c->block_cypher == DES3_BLOCK_CYPHER)) {
 			ta.encrypt = val;
 			ta.encrypter = &oakley_encrypter[val];
+			} else {
+                       ugh = builddiag("%s is not supported",
+			    enum_show(&oakley_enc_names, val));
+			}
 			break;
 		    default:
 			ugh = builddiag("%s is not supported"
@@ -923,9 +1679,54 @@
 			    ta.auth = val;
 			}
 			break;
+
+#ifdef OPENSSL
+                  case OAKLEY_DSS_SIG:
+                    if ((st->st_connection->key == NULL) ||
+                        (((EVP_PKEY *)(st->st_connection->key))->type != EVP_PKEY_DSA))
+                      ugh = builddiag(
+                      "OAKLEY_DSS_SIG requested, but no DSA key available to sign with. Still unsupported.");
+                    ta.auth = val;
+                    break;
+/*
+ *                case OAKLEY_RSA_SIG:
+ * see after #endif OPENSSL
+ */
+                  case OAKLEY_RSA_ENC:
+                    if (!have_rsa_keypair(st))
+                      ugh = builddiag(
+                      "OAKLEY_RSA_ENC requested, but no cert available to encrypt with");
+                    ta.auth = val;
+                    break;
+                  case OAKLEY_ELGAMAL_ENC:
+                    if (!have_elgamal_keypair(st))
+                      ugh = builddiag(
+                      "OAKLEY_ELGAMAL_ENC requested, but no cert available to encrypt with");
+                    ta.auth = val;
+                    break;
+                  case OAKLEY_RSA_ENC_REV:
+                    if (!have_rsa_keypair(st))
+                      ugh = builddiag(
+                      "OAKLEY_RSA_ENC_REV requested, but no cert available to encrypt with");
+                    ta.auth = val;
+                    break;
+                  case OAKLEY_ELGAMAL_ENC_REV:
+                    if (!have_elgamal_keypair(st))
+                      ugh = builddiag(
+                      "OAKLEY_ELGAMAL_ENC_REV requested, but no cert available to encrypt with");
+                    ta.auth = val;
+                    break;
+
 		    case OAKLEY_RSA_SIG:
+		    if (!use_openssl(st->st_connection))
+		    {
+#endif /* OPENSSL, !use_openssl */
 			/* Accept if policy specifies RSASIG or is default */
+#ifndef OPENSSL
 			if ((iap & POLICY_RSASIG) == LEMPTY)
+#else
+                       if ((iap & POLICY_OPENSSL) == LEMPTY)
+#endif
 			{
 			    ugh = "policy does not allow OAKLEY_RSA_SIG authentication";
 			}
@@ -941,6 +1742,15 @@
 			     */
 			    ta.auth = val;
 			}
+#ifdef OPENSSL
+		    } else { /* use_openssl */
+		      if ((st->st_connection->key == NULL) ||
+		        (((EVP_PKEY *)(st->st_connection->key))->type != EVP_PKEY_RSA))
+                      ugh = builddiag(
+		      "OAKLEY_RSA_SIG requested, but no key available to sign with");
+		      ta.auth = val;
+		    }
+#endif
 			break;
 
 		    default:
@@ -1055,6 +1865,7 @@
 	     * Lets finish early and leave.
 	     */
 
+#ifndef OPENSSL
 	    DBG(DBG_PARSING | DBG_CRYPT
 		, DBG_log("Oakley Transform %u accepted", trans.isat_transnum));
 
@@ -1108,6 +1920,14 @@
 	    /* copy over the results */
 	    st->st_oakley = ta;
 	    return NOTHING_WRONG;
+#else
+	    /*
+	     * We store the ta result into the list of candidates
+	     * Afterwards, site policy dictates which of the
+	     * candidates we should select
+	     */
+	    trans_list_append(&tl, &ta, &trans, attr_start, attr_len);
+#endif
 	}
 
 	/* on to next transform */
@@ -1128,9 +1948,77 @@
 		, enum_show(&payload_names, proposal.isap_np));
 	    return BAD_PROPOSAL_SYNTAX;
 	}
-    }
+    } /* for */
+
+#ifndef OPENSSL
     loglog(RC_LOG_SERIOUS, "no acceptable Oakley Transform");
     return NO_PROPOSAL_CHOSEN;
+#else
+    /* We should have a list of hopefuls in the list tl */
+    { /* open scope */
+      u_char *attr_start;
+      size_t attr_len;
+      struct isakmp_transform trans;
+
+      selected = select_trans_candidate(tl, &st->st_oakley, &trans, 
+        &attr_start, &attr_len, st->st_connection->cert_options);
+      trans_list_free(&tl);
+      if (! selected) {
+        log("no acceptable Oakley Transform");
+        return NO_PROPOSAL_CHOSEN;
+      } else {
+        DBG(DBG_PARSING | DBG_CRYPT,
+        DBG_log("Oakley Transform %u accepted", trans.isat_transnum)
+        );
+
+        if (r_sa_pbs != NULL)
+        {
+          struct isakmp_proposal r_proposal = proposal;
+          pb_stream r_proposal_pbs;
+          struct isakmp_transform r_trans = trans;
+          pb_stream r_trans_pbs;
+
+          /* Situation */
+          if (!out_struct(&ipsecdoisit, &ipsec_sit_desc, r_sa_pbs, NULL))
+            passert(FALSE);
+
+          /* Proposal */
+#ifdef EMIT_ISAKMP_SPI
+          r_proposal.isap_spisize = COOKIE_SIZE;
+#else
+          r_proposal.isap_spisize = 0;
+#endif
+          r_proposal.isap_notrans = 1;
+          if (!out_struct(&r_proposal, &isakmp_proposal_desc, r_sa_pbs, &r_proposal_pbs))
+            passert(FALSE);
+
+          /* SPI */
+#ifdef EMIT_ISAKMP_SPI
+          if (!out_raw(my_cookie, COOKIE_SIZE, &r_proposal_pbs, "SPI"))
+            passert(FALSE);
+          r_proposal.isap_spisize = COOKIE_SIZE;
+#else
+          /* none (0) */
+#endif
+
+          /* Transform */
+          r_trans.isat_np = ISAKMP_NEXT_NONE;
+          if (!out_struct(&r_trans, &isakmp_isakmp_transform_desc, 
+            &r_proposal_pbs, &r_trans_pbs))
+            passert(FALSE);
+
+          if (!out_raw(attr_start, attr_len, &r_trans_pbs, "attributes"))
+            passert(FALSE);
+          if (attr_start) pfree(attr_start);
+
+          close_output_pbs(&r_trans_pbs);
+          close_output_pbs(&r_proposal_pbs);
+          close_output_pbs(r_sa_pbs);
+        }     /* if (r_sa_pbs != NULL) */
+      return NOTHING_WRONG;
+      }       /* if (! selected) */
+    }  /* end this scope */
+#endif        /* OPENSSL */
 }
 
 /* Parse the body of an IPsec SA Payload (i.e. Phase 2 / Quick Mode).
@@ -1802,9 +2690,7 @@
 
 		switch (esp_attrs.transid)
 		{
-#if 0	/* we don't feel single DES is safe */
 		    case ESP_DES:
-#endif
 		    case ESP_3DES:
 			break;
 
diff -BbruN freeswan-1.91.orig/pluto/spdb.h freeswan-1.91/pluto/spdb.h
--- freeswan-1.91.orig/pluto/spdb.h	Fri Sep 15 05:09:28 2000
+++ freeswan-1.91/pluto/spdb.h	Tue Jul  3 02:56:35 2001
@@ -24,11 +24,32 @@
     u_int16_t val;
 };
 
+#ifdef OPENSSL
+typedef bool offer_fn(struct state *st);
+/* Addition for OpenSSL: we don't want to offer cipher suites */
+/* which we aren't capable of generating, so I added a function */
+/* parameter 'offer', which takes the state as a parameter, and */
+/* returns either TRUE or FALSE, depending on whether the cipher */
+/* suite is supportable. For instance, there's no point in */
+/* offering to sign things with a DSA signature key, if all you've */
+/* got is an RSA one. */
+/* NB: If the function pointer is set to NULL, it means offer the */
+/* cipher suite under all conditions. The downside to this is that */
+/* another parameter must be added to all the IPsec cipher transforms */
+/* which is always NULL. I suppose we could embed policy information */
+/* within that parameter, e.g. If a pair of endpoints must have */
+/* a particular cipher between them. Trouble is, that information is */
+/* present within ipsec.conf, to some extent -- nd */
+#endif
+
 /* transform */
 struct db_trans {
     u_int8_t transid;	/* Transform-Id */
     struct db_attr *attrs;	/* array */
     int attr_cnt;	/* number of elements */
+#ifdef OPENSSL
+    offer_fn *offer;
+#endif
 };
 
 /* proposal */
@@ -56,9 +77,12 @@
 };
 
 /* The oakley sadb is subscripted by a bitset with members
- * from POLICY_PSK and POLICY_RSASIG.
+ * from POLICY_PSK and POLICY_RSASIG/OPENSSL.
  */
 extern struct db_sa oakley_sadb[1 << 2];
+#ifdef OPENSSL
+extern struct db_sa oakley_sadb2[1 << 2];
+#endif
 
 /* The ipsec sadb is subscripted by a bitset with members
  * from POLICY_ENCRYPT, POLICY_AUTHENTICATE, POLICY_COMPRESS
diff -BbruN freeswan-1.91.orig/pluto/state.c freeswan-1.91/pluto/state.c
--- freeswan-1.91.orig/pluto/state.c	Mon Jun  4 23:14:28 2001
+++ freeswan-1.91/pluto/state.c	Tue Jul  3 02:58:33 2001
@@ -359,6 +359,16 @@
     pfreeany(st->st_esp.our_keymat);
     pfreeany(st->st_esp.peer_keymat);
 
+#ifdef OPENSSL
+    /* Clean out the stuff for revised PK encryption mode */
+    pfreeany(st->st_ne_i.ptr);
+    memset(&st->st_ks_i, 0, sizeof(st->st_ks_i));
+    memset(st->st_ne_i_iv, 0, MAX_DIGEST_LEN);
+    pfreeany(st->st_ne_r.ptr);
+    memset(&st->st_ks_r, 0, sizeof(st->st_ks_r));
+    memset(st->st_ne_r_iv, 0, MAX_DIGEST_LEN);
+#endif
+
     pfree(st);
 }
 
diff -BbruN freeswan-1.91.orig/pluto/state.h freeswan-1.91/pluto/state.h
--- freeswan-1.91.orig/pluto/state.h	Thu Mar  1 22:19:46 2001
+++ freeswan-1.91/pluto/state.h	Tue Jul  3 02:58:39 2001
@@ -145,6 +145,15 @@
     u_int8_t           st_rcookie[COOKIE_SIZE];/* Responder Cookie */
     chunk_t            st_nr;                  /* Nr nonce */
 
+#ifdef OPENSSL
+    /* key material for revised public key information */
+    u_int8_t           st_ne_i_iv[MAX_DIGEST_LEN];
+    chunk_t            st_ne_i;                /* key for initiator payloads */
+    keysched           st_ks_i;
+    u_int8_t           st_ne_r_iv[MAX_DIGEST_LEN];
+    chunk_t            st_ne_r;                /* key for responder payloads */
+    keysched           st_ks_r;
+#endif
 
   /* my stuff */
 
diff -BbruN freeswan-1.91.orig/pluto/version.c freeswan-1.91/pluto/version.c
--- freeswan-1.91.orig/pluto/version.c	Wed May 30 09:02:20 2001
+++ freeswan-1.91/pluto/version.c	Tue Jul  3 04:02:32 2001
@@ -1,2 +1,2 @@
 /* silly pointless RCSID $Id: version.c,v 1.19 2001/05/30 13:02:20 henry Exp $ */
-static const char freeswan_version[] = "1.91";
+static const char freeswan_version[] = "FreeSWAN-1.91-pkix1";
diff -BbruN freeswan-1.91.orig/pluto/whack.c freeswan-1.91/pluto/whack.c
--- freeswan-1.91.orig/pluto/whack.c	Mon May 14 16:37:48 2001
+++ freeswan-1.91/pluto/whack.c	Tue Jul  3 03:00:13 2001
@@ -1,4 +1,6 @@
 /* command interface to Pluto
+ *
+ * Modified by Luc Lanthier based on work from:
  * Copyright (C) 1997 Angelos D. Keromytis.
  * Copyright (C) 1998, 1999  D. Hugh Redelmeier.
  *
@@ -82,6 +84,10 @@
 	    " [--compress]"
 	    " [--tunnel]"
 	    " [--pfs]"
+#ifdef OPENSSL
+	    " [--openssl]"
+#endif
+
 	    " \\\n   "
 	    " [--ikelifetime <seconds>]"
 	    " [--ipseclifetime <seconds>]"
@@ -90,6 +96,14 @@
 	    " [--reykeyfuzz <percentage>]"
 	    " \\\n   "
 	    " [--keyingtries <count>]"
+#ifdef OPENSSL
+	    " \\\n   "
+	    " [--certfile <file name>]"
+	    " [--certopts <[!]opt1,[!]opt2,...,[!]optN>]"
+	    " [--peerfile <file name>]"
+	    " [--keyfile <file name>]"
+	    " [--certpath <file name>]"
+#endif
 	    "\n\n"
 	"routing: whack"
 	    " (--route | --unroute)"
@@ -142,6 +156,9 @@
 	"shutdown: whack"
 	    " --shutdown"
 	    "\n\n"
+	"DES type: whack"
+	    " [--force_encrypt_cypher <des/3des>]"
+	    "\n\n"
 	"FreeS/WAN %s\n",
 	freeswan_version);
 }
@@ -203,6 +220,14 @@
     OPT_KEYID,
     OPT_PUBKEYRSA,
 
+#ifdef OPENSSL
+    OPT_CERTFILE,
+    OPT_CERTOPTS,
+    OPT_PEERFILE,
+    OPT_KEYFILE,
+    OPT_CERTPATH,
+#endif
+
     OPT_ROUTE,
     OPT_UNROUTE,
 
@@ -234,7 +259,11 @@
 
 #   define CD_POLICY_FIRST  CD_PSK
     CD_PSK,	/* same order as POLICY_* */
+#ifndef OPENSSL
     CD_RSASIG,	/* same order as POLICY_* */
+#else
+    CD_OPENSSL,	/* same order as POLICY_* */
+#endif
     CD_ENCRYPT,	/* same order as POLICY_* */
     CD_AUTHENTICATE,	/* same order as POLICY_* */
     CD_COMPRESS,	/* same order as POLICY_* */
@@ -247,6 +277,8 @@
     CD_CONNIPV4,
     CD_CONNIPV6,
 
+    CD_FORCE_ENCRYPT_CYPHER,   /* to force DES or 3DES only */
+
     CD_IKELIFETIME,
     CD_IPSECLIFETIME,
     CD_RKMARGIN,
@@ -319,7 +351,12 @@
     { "updown", required_argument, NULL, CD_UPDOWN + OO },
 
     { "psk", no_argument, NULL, CD_PSK + OO },
+#ifndef OPENSSL
     { "rsasig", no_argument, NULL, CD_RSASIG + OO },
+#else
+    { "rsasig", no_argument, NULL, CD_OPENSSL + OO },
+    { "openssl", no_argument, NULL, CD_OPENSSL + OO },
+#endif
 
     { "encrypt", no_argument, NULL, CD_ENCRYPT + OO },
     { "authenticate", no_argument, NULL, CD_AUTHENTICATE + OO },
@@ -339,6 +376,16 @@
     { "rekeywindow", required_argument, NULL, CD_RKMARGIN + OO + NUMERIC_ARG },	/* OBSOLETE */
     { "rekeyfuzz", required_argument, NULL, CD_RKFUZZ + OO + NUMERIC_ARG },
     { "keyingtries", required_argument, NULL, CD_KTRIES + OO + NUMERIC_ARG },
+/* DES Support */
+    { "force_encrypt_cypher", required_argument, NULL, CD_FORCE_ENCRYPT_CYPHER + OO },
+
+#ifdef OPENSSL
+    { "certfile", required_argument, NULL, OPT_CERTFILE + OO },
+    { "certopts", required_argument, NULL, OPT_CERTOPTS + OO },
+    { "peerfile", required_argument, NULL, OPT_PEERFILE + OO },
+    { "keyfile", required_argument, NULL, OPT_KEYFILE + OO },
+    { "certpath", required_argument, NULL, OPT_CERTPATH + OO },
+#endif
 
 #ifdef DEBUG
     { "debug-none", no_argument, NULL, DBGOPT_NONE + OO },
@@ -443,7 +490,11 @@
 	    /* client is 0.0.0.0/32: Opportunism connection */
 	    if (!isanyaddr(&this->host_addr))
 		diag("normal client network must not be 0.0.0.0/32 or 0::0/128");
+#ifndef OPENSSL
 	    if ((policy & (POLICY_PSK | POLICY_RSASIG)) != POLICY_RSASIG)
+#else
+	    if ((policy & (POLICY_PSK | POLICY_OPENSSL)) != POLICY_OPENSSL)
+#endif
 		diag("only RSASIG is supported for opportunism");
 	    if ((policy & POLICY_PFS) == 0)
 		diag("PFS required for opportunism");
@@ -492,6 +544,7 @@
     msg.sa_rekey_margin = SA_REPLACEMENT_MARGIN_DEFAULT;
     msg.sa_rekey_fuzz = SA_REPLACEMENT_FUZZ_DEFAULT;
     msg.sa_keying_tries = SA_REPLACEMENT_RETRIES_DEFAULT;
+    msg.block_cypher = FORCE_ENCRYPT_CYPHER_DEFAULT;
 
     msg.addr_family = AF_INET;
     msg.tunnel_addr_family = AF_INET;
@@ -672,6 +725,37 @@
 	    msg.whack_async = TRUE;
 	    continue;
 
+#ifdef OPENSSL
+      case OPT_CERTFILE:
+          if (strlen(optarg) >= FILE_NAME_LIMIT)
+              diagq("certificate file name too long", optarg);
+              strcpy(msg.whack_certfile, optarg);
+        continue;
+
+      case OPT_CERTOPTS:
+          if (strlen(optarg) >= CERT_OPTIONS_LIMIT)
+              diagq("certificate file name too long", optarg);
+              strcpy(msg.whack_certopts, optarg);
+        continue;
+
+      case OPT_PEERFILE:
+          if (strlen(optarg) >= FILE_NAME_LIMIT)
+              diagq("peer certificate file name too long", optarg);
+              strcpy(msg.whack_peerfile, optarg);
+        continue;
+
+      case OPT_KEYFILE:
+          if (strlen(optarg) >= FILE_NAME_LIMIT)
+              diagq("key file name too long", optarg);
+              strcpy(msg.whack_keyfile, optarg);
+        continue;
+
+      case OPT_CERTPATH:
+          if (strlen(optarg) >= PATH_NAME_LIMIT)
+              diagq("certificate path name too long", optarg);
+              strcpy(msg.whack_certpath, optarg);
+        continue;
+#endif
 
 	/* Connection Description options */
 
@@ -750,7 +834,11 @@
 	    continue;
 
 	case CD_PSK:		/* --psk */
+#ifndef OPENSSL
 	case CD_RSASIG:	/* --rsasig */
+#else
+	case CD_OPENSSL:	/* --rsasig */
+#endif
 	case CD_ENCRYPT:	/* --encrypt */
 	case CD_AUTHENTICATE:	/* --authenticate */
 	case CD_COMPRESS:	/* --compress */
@@ -781,6 +869,20 @@
 	    msg.sa_keying_tries = opt_whole;
 	    continue;
 
+	/* DES support */
+	case CD_FORCE_ENCRYPT_CYPHER:   /* --force_encrypt_cypher <des/3des> */
+	if (strcmp("des", optarg) == 0) {
+	  msg.block_cypher = DES_BLOCK_CYPHER;
+	}
+	if (strcmp("3des", optarg) == 0) {
+	  msg.block_cypher = DES3_BLOCK_CYPHER;
+	}
+	/* else */
+	if ((strcmp("3des", optarg) != 0) && (strcmp("des", optarg) != 0)) {
+	  diag("--force_encrypt_cypher must have a parameter of either 'des' or '3des'");
+	}
+	continue;
+
 	case OPT_KEYID:	/* --keyid <identity> */
 	    msg.whack_key = TRUE;
 	    msg.keyid = optarg;	/* decoded by Pluto */
diff -BbruN freeswan-1.91.orig/pluto/whack.h freeswan-1.91/pluto/whack.h
--- freeswan-1.91.orig/pluto/whack.h	Sun Jan 28 16:03:05 2001
+++ freeswan-1.91/pluto/whack.h	Tue Jul  3 03:00:14 2001
@@ -16,6 +16,10 @@
 
 #include <freeswan.h>
 
+#ifdef OPENSSL
+#include "openssl_defs.h"
+#endif
+
 /*
  * Since the message remains on one host, native representation is used.
  * Think of this as horizontal microcode: all selected operations are
@@ -83,6 +87,14 @@
     enum pubkey_alg pubkey_alg;
     chunk_t keyval;	/* chunk */
 
+#ifdef OPENSSL
+    char whack_certfile[FILE_NAME_LIMIT];
+    char whack_certopts[CERT_OPTIONS_LIMIT];
+    char whack_peerfile[FILE_NAME_LIMIT];
+    char whack_keyfile[FILE_NAME_LIMIT];
+    char whack_certpath[PATH_NAME_LIMIT];
+#endif
+
     /* for WHACK_ROUTE: */
     bool whack_route;
 
@@ -110,6 +122,10 @@
 
     /* for WHACK_SHUTDOWN */
     bool whack_shutdown;
+
+    /* for des type to use */
+    lset_t block_cypher;
+
 
     /* space for strings (hope there is enough room):
      * Note that pointers don't travel on wire.
diff -BbruN freeswan-1.91.orig/pluto/x_sobj.c freeswan-1.91/pluto/x_sobj.c
--- freeswan-1.91.orig/pluto/x_sobj.c	Wed Dec 31 19:00:00 1969
+++ freeswan-1.91/pluto/x_sobj.c	Tue Jul  3 03:00:39 2001
@@ -0,0 +1,36 @@
+#ifdef OPENSSL
+#include "x_sobj.h"
+
+IMPLEMENT_STACK_OF(X509_OBJECT)
+
+X509_OBJECT *
+X509_OBJECT_new( const int type, void *p )
+{
+  X509_OBJECT *ret = Malloc(sizeof(X509_OBJECT));
+
+  if (ret == NULL) return ret;
+  switch(type) {
+  case X509_LU_X509:
+    ret->type = type;
+    ret->data.x509 = (X509 *)p;
+    break;
+  case X509_LU_CRL:
+    ret->type = type;
+    ret->data.crl = (X509_CRL *)p;
+    break;
+  default: /* Unknown type */
+    Free((char *)ret);
+    ret = NULL;
+    break;
+  }
+  return ret;
+}
+
+void
+X509_OBJECT_free(X509_OBJECT *x)
+{
+  if (!x) return;
+  X509_OBJECT_free_contents(x);
+  Free((char *)x);
+}
+#endif /* OPENSSL */
diff -BbruN freeswan-1.91.orig/pluto/x_sobj.h freeswan-1.91/pluto/x_sobj.h
--- freeswan-1.91.orig/pluto/x_sobj.h	Wed Dec 31 19:00:00 1969
+++ freeswan-1.91/pluto/x_sobj.h	Tue Jul  3 03:00:39 2001
@@ -0,0 +1,12 @@
+#ifndef X_SOBJ_H
+#define X_SOBJ_H
+
+#include <openssl/x509.h>
+#include <openssl/x509_vfy.h>
+
+DECLARE_STACK_OF(X509_OBJECT)
+
+X509_OBJECT *X509_OBJECT_new( const int type, void *ptr );
+void X509_OBJECT_free(X509_OBJECT *x);
+
+#endif
